#include<stdio.h>


union conv_union{             //This union is used to convert the data from
       unsigned char bytes[4];//big-endian (Motorola/68000) format to little
       unsigned long value;   //endian (Intel/8086).
      };



unsigned char file_header[16];   //      The file header

struct chunk{                    //      Each file chunk
      unsigned char type[4];     //chunk type
      unsigned char size[4];     //size of chunk -4
      unsigned char entries[4];  //number of entires
       };


char *name_chunk(unsigned char c) //returns the name of a chunk (to display)
{
    switch(c)
    {

       case 0x16:return("Material list");
       case 0x17:return("Vertex list");
       case 0x18:return("U&V list");
       case 0x35:return("Polygon list");
       case 0x36:return("File Name");
       case 0x1a:return("Material/polygon list");
       default :return("Unrecognised **PROBABLE ERROR**");
    }
}


main(int argc,char *argv[])
{
    FILE *FP;
    int loop;
    unsigned chunk_count=0;
    unsigned long count,chunk_size,number_entries;
    struct chunk chunk_header;
    union conv_union converter;
    unsigned char buffer;

    if(argc<2)       //Was a file name specified?
    {
      putchar(7);
      printf("\n\n ERROR!!!   ");
      puts("File name required\n");
      return(1);    //if not, exit
    }

    if ((FP = fopen(argv[1], "rb"))== NULL)   //open the specified file
    {
      putchar(7);
      puts("\n\n ERROR!!!  Cannot open input file.\n");
      return(1);
    }

    count=fread(file_header,1,16,FP);        //Read 16 byte file header

    if(count<16)
    {
       putchar(7);
       puts("\n\n ERROR!!!  File header truncated.\n");     //exit if file header short
       return(1);
    }

    printf("File header Data: ");      //Print file header to the screen
    for(loop=0;loop<16;loop++)
    {
      printf("%02hX ",(file_header[loop]));
    }
    puts("\nReading Chunks:");

    while(kbhit())getch();
    //************** CHUNK PARSER
    count=fread(&chunk_header,(sizeof(struct chunk)-2),1,FP);
      //read header for next chunk  (first chunk starts 2 bytes early?)

    while(count>0)                     //while we're not at the end-of-file
    {
      chunk_count++;                  //add one to chunk count


      // Convert chunk size to little endian format
      converter.bytes[0]=chunk_header.size[3];
      converter.bytes[1]=chunk_header.size[2];
      converter.bytes[2]=chunk_header.size[1];
      converter.bytes[3]=chunk_header.size[0];
      chunk_size=converter.value;

      chunk_size-=4;  //Total Chunk size is usually -4
      if(chunk_header.type[3]==0x1a)chunk_size+=8; //1A chunks aren't :)
      if(chunk_count==1)chunk_size+=2;             //The first name
						//chunk starts 2 bytes early

      // Convert number of entries to little endian format
      converter.bytes[0]=chunk_header.entries[3];
      converter.bytes[1]=chunk_header.entries[2];
      converter.bytes[2]=chunk_header.entries[1];
      converter.bytes[3]=chunk_header.entries[0];
      number_entries=converter.value;


      printf("\nChunk #%d, Type: %02hXh [",chunk_count,chunk_header.type[3]);
      printf(name_chunk(chunk_header.type[3]));
      printf("]\n");

      printf("Chunk size = %lu bytes, Number of entries = %lu\n",chunk_size,number_entries);

      while(!kbhit());
      while(kbhit())getch();



      if(chunk_header.type[3]==0x16)
      {     //If it's a MAT-list type chunk, chunk size may not be good
	for(count=0;count<number_entries;count++)
	{
	   buffer=1;     //use number of items to read file names.
	   while(buffer!=0)
	   {
	     if(fread(&buffer,1,1,FP)==0)
	     {
	      putchar(7);
	      puts("\n\n\n ERROR!!!  Unexpected end of file!\n");
	      return(1);
	     }
	     putchar(buffer);
	   }
	}
      }
      else for(count=0;count<chunk_size;count++)
      {        //data type chunk- use chunk size
	 if(fread(&buffer,1,1,FP)==0)
	 {
	   putchar(7);
	   puts("\n\n\n ERROR!!!  Unexpected end of file!\n");
	   return(1);
	 }
	 if(chunk_header.type[3]==0x36) putchar(buffer);
	 else printf("%02hX ",buffer);
	 if(count%25==24) putchar('\n');
      }
      putch('\n');


      count=fread(&chunk_header,12,1,FP);//Read header for next ckunk
    }


    fclose(FP);                        //Close input file

    printf("\nChunk count :%u\n",chunk_count);


    return(0);                         //Exit program
}